-- name: \\#386dff\\Goomba Simulator
-- incompatible: moveset
-- description: Made By Pepitosxd,Base code that I used to add the Goomba 64 model: Lucho_Gamer, Goomba Model: MrGameAndSketch, Recolorability: Ale64

   -- goomba jump height

function mario_on_set_action(m)
    if m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or m.action == ACT_TRIPLE_JUMP or m.action == ACT_SPECIAL_TRIPLE_JUMP or m.action == ACT_STEEP_JUMP or m.action == ACT_SIDE_FLIP or m.action == ACT_RIDING_SHELL_JUMP or m.action == ACT_BACKFLIP or m.action == ACT_WALL_KICK_AIR  or m.action == ACT_LONG_JUMP or m.action == ACT_METAL_WATER_JUMP then
        m.vel.y = m.vel.y * 0.6
	end	
end
-----------
-- hooks --
-----------

hook_event(HOOK_ON_SET_MARIO_ACTION, mario_on_set_action)

function nocannonsever(m)
    if m.action == ACT_SHOT_FROM_CANNON then
        set_mario_action(m, ACT_FORWARD_AIR_KB, 0)
        m.vel.y = 50
        m.vel.x = 40
        soft_reset_camera(m.area.camera)
    end
end


E_MODEL_PLAYERGOOMBA64 = smlua_model_util_get_id("playergoomba64_geo")

ACT_FLUTTER = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)
ACT_FLUTTER_FREEFALL = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)

local yoshi_model = false

ANGLE_QUEUE_SIZE = 9

gEventTable = {}

gStateExtras = {}
for i = 0, (MAX_PLAYERS - 1) do
    gStateExtras[i] = {}
    local m = gMarioStates[i]
    local e = gStateExtras[i]
    e.canflutter = true
    e.angleDeltaQueue = {}
    for j = 0, (ANGLE_QUEUE_SIZE - 1) do e.angleDeltaQueue[j] = 0 end
    e.animFrame = 0
end

function act_flutter(m)
    local e = gStateExtras[m.playerIndex]

    common_air_action_step(m, ACT_JUMP_LAND, MARIO_ANIM_RUNNING_UNUSED, AIR_STEP_NONE)

    play_sound(SOUND_ACTION_TWIRL, m.marioObj.header.gfx.cameraToObject)

    if m.actionTimer == 0 then
        m.actionState = m.actionArg
        play_sound(SOUND_GENERAL_yoshi_TALK, m.marioObj.header.gfx.cameraToObject)
    end

    m.vel.y = m.actionTimer / 2
    if m.prevAction ~= ACT_TRIPLE_JUMP then  
        if m.actionTimer > 30 or (m.controller.buttonDown & A_BUTTON) == 0 then
            set_mario_action(m, ACT_FREEFALL, 0)
        end
    else
        if m.actionTimer > 30 or (m.controller.buttonDown & A_BUTTON) == 0 then
            set_mario_action(m, ACT_FLUTTER_FREEFALL, 0)
        end
    end

    set_mario_animation(m, MARIO_ANIM_RUNNING_UNUSED)
    set_anim_to_frame(m, e.animFrame)
    e.animFrame = e.animFrame + 10
    if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
        e.animFrame = e.animFrame - m.marioObj.header.gfx.animInfo.curAnim.loopEnd
    end

    m.actionTimer = m.actionTimer + 1
    return 0
end

function act_flutter_freefall(m)
    local e = gStateExtras[m.playerIndex]

    common_air_action_step(m, ACT_TRIPLE_JUMP_LAND, MARIO_ANIM_FORWARD_SPINNING, AIR_STEP_NONE)
end

function yoshi_command(msg)
    if msg == 'on' then
        gPlayerSyncTable[0].heMario = true
        yoshi_model = true
		gPlayerSyncTable[0].yoshivoicecheck = 1
        djui_chat_message_create('The Goomba model is \\#05ff1e\\on')
        return true
    elseif msg == "off" then
        gPlayerSyncTable[0].heMario = false
        yoshi_model = false
		gPlayerSyncTable[0].yoshivoicecheck = 0
        djui_chat_message_create('The Goomba model is \\#ff0000\\off')
        return true
    end
    return false
end

function mario_update_local(m)
    if yoshi_model == true then
        gPlayerSyncTable[0].modelId = E_MODEL_PLAYERGOOMBA64
    end
    if yoshi_model == false then
		gPlayerSyncTable[0].modelId = nil
	end
end

function mario_update(m)
    local e = gStateExtras[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    local np = gNetworkPlayers[m.playerIndex]

    if yoshi == true and gMarioStates[0].character.type == 0 then

        if e.canflutter == true then
            if (m.controller.buttonPressed & A_BUTTON) ~= 0 and m.actionTimer > 0 then
                if m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or m.action == ACT_TRIPLE_JUMP or m.action == ACT_LONG_JUMP or m.action == ACT_BACKFLIP or m.action == ACT_SIDE_FLIP or m.action == ACT_FREEFALL then
                    set_mario_action(m, ACT_FLUTTER, 0)
                    e.canflutter = false
                end
            end
        end
        if m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or m.action == ACT_TRIPLE_JUMP or m.action == ACT_LONG_JUMP or  m.action == ACT_SIDE_FLIP or m.action == ACT_FREEFALL or m.action == ACT_BACKFLIP then
            m.actionTimer = m.actionTimer + 1
        end
        if m.action == ACT_JUMP_LAND or m.action == ACT_DOUBLE_JUMP or m.action == ACT_TRIPLE_JUMP_LAND or m.action == ACT_IDLE or m.action == ACT_WALKING then
            e.canflutter = true
        end

        --No Walljump from flutter
        if e.canflutter == false and m.action == ACT_AIR_HIT_WALL then
            set_mario_action(m, ACT_BUTT_SLIDE_AIR, 0)
        end
    end

    if s.heMario then
        np.overrideModelIndex = 0
    else
        np.overrideModelIndex = np.modelIndex
    end

    if m.playerIndex == 0 then
        mario_update_local(m)
    end

    if gPlayerSyncTable[m.playerIndex].modelId ~= nil then
        obj_set_model_extended(m.marioObj, gPlayerSyncTable[m.playerIndex].modelId)
    end

    if gPlayerSyncTable[0].modelId ~= E_MODEL_PLAYERGOOMBA64 then return end
end

function mario_on_set_action(m)
    if yoshi == true and gMarioStates[0].character.type == 0 then

        if m.action == ACT_DIVE and m.prevAction ~= ACT_TRIPLE_JUMP and (m.marioObj.collidedObjInteractTypes & INTERACT_GRABBABLE) == 0 then
            set_mario_action(m, ACT_JUMP_KICK, 0)
            if m.forwardVel > 0 then
                m.forwardVel = m.forwardVel -15
            end
        end
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_ON_SET_MARIO_ACTION, mario_on_set_action)

hook_mario_action(ACT_FLUTTER,     { every_frame = act_flutter })
hook_mario_action(ACT_FLUTTER_FREEFALL,     { every_frame = act_flutter_freefall })

hook_chat_command('goomba', "[\\#ffffff\\on\\#ffffff\\|\\#ffffff\\off\\#ffffff\\] turn \\#ffffff\\the Goomba model\\#ffffff\\ \\#ffffff\\on \\#ffffff\\or \\#ffffff\\off", yoshi_command)

for i=0,(MAX_PLAYERS-1) do
    local s = gPlayerSyncTable[i]
    s.heMario = false
end